---
title: box-shadow
slug: Web/CSS/box-shadow
tags:
  - CSS
  - CSS Backgrounds and Borders
  - CSS Property
  - CSS Styles
  - HTML Colors
  - Reference
  - Shadows
  - Styles
  - Styling HTML
  - box-shadow
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>box-shadow</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property adds shadow effects around an element's frame. You can set multiple effects separated by commas.</span> A box shadow is described by X and Y offsets relative to the element, blur and spread radius, and color.</p>

<div>{{EmbedInteractiveExample("pages/css/box-shadow.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The <code>box-shadow</code> property enables you to cast a drop shadow from the frame of almost any element. If a {{cssxref("border-radius")}} is specified on the element with a box shadow, the box shadow takes on the same rounded corners. The z-ordering of multiple box shadows is the same as multiple <a href="/en-US/CSS/text-shadow">text shadows</a> (the first specified shadow is on top).</p>

<p><a href="/en-US/docs/Web/CSS/CSS_Box_Model/Box-shadow_generator">Box-shadow generator</a> is an interactive tool allowing you to generate a <code>box-shadow</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
box-shadow: none;

/* offset-x | offset-y | color */
box-shadow: 60px -16px teal;

/* offset-x | offset-y | blur-radius | color */
box-shadow: 10px 5px 5px black;

/* offset-x | offset-y | blur-radius | spread-radius | color */
box-shadow: 2px 2px 2px 1px rgba(0, 0, 0, 0.2);

/* inset | offset-x | offset-y | color */
box-shadow: inset 5em 1em gold;

/* Any number of shadows, separated by commas */
box-shadow: 3px 3px red, -1em 0 0.4em olive;

/* Global keywords */
box-shadow: inherit;
box-shadow: initial;
box-shadow: unset;
</pre>

<p>Specify a single box-shadow using:</p>

<ul>
 <li>Two, three, or four <code><a href="/en-US/docs/Web/CSS/length">&lt;length&gt;</a></code> values.

  <ul>
   <li>If only two values are given, they are interpreted as <code><a href="#offset-x">&lt;offset-x&gt;&lt;offset-y&gt;</a></code> values.</li>
   <li>If a third value is given, it is interpreted as a <code><a href="#blur-radius">&lt;blur-radius&gt;</a></code>.</li>
   <li>If a fourth value is given, it is interpreted as a <code><a href="#spread-radius">&lt;spread-radius&gt;</a></code>.</li>
  </ul>
 </li>
 <li>Optionally, the <code><a href="#inset">inset</a></code> keyword.</li>
 <li>Optionally, a <code><a href="#color">&lt;color&gt;</a></code> value.</li>
</ul>

<p>To specify multiple shadows, provide a comma-separated list of shadows.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt id="inset"><code>inset</code></dt>
 <dd>If not specified (default), the shadow is assumed to be a drop shadow (as if the box were raised above the content).<br>
 The presence of the <code>inset</code> keyword changes the shadow to one inside the frame (as if the content was depressed inside the box). Inset shadows are drawn inside the border (even transparent ones), above the background, but below content.</dd>
 <dt id="offset-x"><code>&lt;offset-x&gt;</code> <code>&lt;offset-y&gt;</code></dt>
 <dd>These are two {{cssxref("&lt;length&gt;")}} values to set the shadow offset. <code>&lt;offset-x&gt;</code> specifies the horizontal distance. Negative values place the shadow to the left of the element. <code>&lt;offset-y&gt;</code> specifies the vertical distance. Negative values place the shadow above the element. See {{cssxref("&lt;length&gt;")}} for possible units.<br>
 If both values are <code>0</code>, the shadow is placed behind the element (and may generate a blur effect if <code>&lt;blur-radius&gt;</code> and/or <code>&lt;spread-radius&gt;</code> is set).</dd>
 <dt id="blur-radius"><code>&lt;blur-radius&gt;</code></dt>
 <dd>This is a third {{cssxref("&lt;length&gt;")}} value. The larger this value, the bigger the blur, so the shadow becomes bigger and lighter. Negative values are not allowed. If not specified, it will be <code>0</code> (the shadow's edge is sharp). The specification does not include an exact algorithm for how the blur radius should be calculated, however, it does elaborate as follows:</dd>
 <dd>
 <blockquote>…for a long, straight shadow edge, this should create a color transition the length of the blur distance that is perpendicular to and centered on the shadow’s edge, and that ranges from the full shadow color at the radius endpoint inside the shadow to fully transparent at the endpoint outside it.</blockquote>
 </dd>
 <dt id="spread-radius"><code>&lt;spread-radius&gt;</code></dt>
 <dd>This is a fourth {{cssxref("&lt;length&gt;")}} value. Positive values will cause the shadow to expand and grow bigger, negative values will cause the shadow to shrink. If not specified, it will be <code>0</code> (the shadow will be the same size as the element).</dd>
 <dt id="color"><code>&lt;color&gt;</code></dt>
 <dd>See {{cssxref("&lt;color&gt;")}} values for possible keywords and notations.<br>
 If not specified, it defaults to {{cssxref("currentcolor")}}.</dd>
</dl>

<h3 id="Interpolation">Interpolation</h3>

<p>Each shadow in the list (treating <code>none</code> as a 0-length list) is interpolated via the color (as color) component, and x, y, blur, and (when appropriate) spread (as length) components. For each shadow, if both input shadows are or are not <code>inset</code>, then the interpolated shadow must match the input shadows in that regard. If any pair of input shadows has one <code>inset</code> and the other not <code>inset</code>, the entire shadow list is uninterpolable. If the lists of shadows have different lengths, then the shorter list is padded at the end with shadows whose color is <code>transparent</code>, all lengths are <code>0</code>, and whose <code>inset</code> (or not) matches the longer list.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_three_shadows">Setting three shadows</h3>

<p>In this example, we include three shadows: an inset shadow, a regular drop shadow, and a 2px shadow that creates a border effect (we could have used an {{cssxref('outline')}} instead for that third shadow).</p>

<div id="Examples1">
<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;blockquote&gt;&lt;q&gt;You may shoot me with your words,&lt;br/&gt;
You may cut me with your eyes,&lt;br/&gt;
You may kill me with your hatefulness,&lt;br/&gt;
But still, like air, I'll rise.&lt;/q&gt;
&lt;p&gt;&amp;mdash; Maya Angelou&lt;/p&gt;
&lt;/blockquote&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">blockquote {
  padding: 20px;
  box-shadow:
       inset 0 -3em 3em rgba(0,0,0,0.1),
             0 0  0 2px rgb(255,255,255),
             0.3em 0.3em 1em rgba(0,0,0,0.3);
}</pre>
</div>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Setting_three_shadows', '300', '300')}}</p>

<h3 id="Setting_zero_for_offset_and_blur">Setting zero for offset and blur</h3>

<div id="Examples2">
<p>When the <code>x-offset</code>, <code>y-offset</code>, and <code>blur</code> are all zero, the box shadow will be a solid-colored outline of equal-size on all sides. The shadows are drawn back to front, so the first shadow sits on top of subsequent shadows. When the <code>border-radius</code> is set to 0, as is the default, the corners of the shadow will be, well, corners. Had we put in a <code>border-radius</code> of any other value, the corners would have been rounded.</p>

<p>We added a margin the size of the widest box-shadow to ensure the shadow doesn't overlap adjacent elements or go beyond the border of the containing box. A box-shadow does not impact <a href="/en-US/docs/Web/CSS/CSS_Box_Model">box model</a> dimensions.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;&lt;p&gt;Hello World&lt;/p&gt;&lt;/div&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">p {
  box-shadow: 0 0 0 2em #F4AAB9,
              0 0 0 4em #66CCFF;
  margin: 4em;
  padding:1em;
}</pre>

<h4 id="Result_2">Result</h4>
</div>

<p>{{EmbedLiveSample('Setting_zero_for_offset_and_blur', '300', '300')}}</p>

<h2 class="cleared" id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Backgrounds', '#box-shadow', 'box-shadow')}}</td>
   <td>{{Spec2('CSS3 Backgrounds')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.box-shadow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{cssxref("&lt;color&gt;")}} data type</li>
 <li>Other color-related properties: {{cssxref("color")}}, {{cssxref("background-color")}}, {{cssxref("border-color")}}, {{cssxref("outline-color")}}, {{cssxref("text-decoration-color")}}, {{cssxref("text-emphasis-color")}}, {{cssxref("caret-color")}}, and {{cssxref("column-rule-color")}}</li>
 <li>{{cssxref("text-shadow")}}</li>
 <li><a href="/en-US/docs/Web/HTML/Applying_color">Applying color to HTML elements using CSS</a></li>
</ul>
